Attribute VB_Name = "modUtil"
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long

Dim QF As Currency
Dim OldQC As Currency
Dim MinCur As Currency
Dim MaxCur As Currency
Dim QTimeVal As Double

Dim Ar() As Long
Const Max As Long = 9999999


Private Function ClampDummy(ByVal r As Long) As Long
End Function

Private Function ClampIf(ByVal r As Long) As Long
  If r > 255 Then r = 255 Else If r < 0 Then r = 0
  ClampIf = r
End Function

Private Function ClampCmov(ByVal r As Long) As Long
  If r > 77 Then r = 77 Else If r < 0 Then r = 0
  ClampCmov = r
End Function

Private Function ClampMath(ByVal r As Long) As Long
  r = (r > 255) * (r - 255) - r * (r > 0)
  ClampMath = r
End Function

Private Function ClampLogic(ByVal r As Long) As Long
  r = (r And (r > 0)) - ((r - 255) And (r > 255))
  ClampLogic = r
End Function


Private Sub PrepareArray(ByRef Ar() As Long)
  Dim i As Long
  For i = 0 To Max
    Ar(i) = (Rnd - 0.5) * 65536
  Next i
End Sub


Sub Main()
  Dim i As Long
  Dim tDummy As Double
  Dim tIf    As Double
  Dim tCmov  As Double
  Dim tMath  As Double
  Dim tLogic As Double

  ReDim Ar(Max)

  PrepareArray Ar
  QTimeReset 0
  For i = 0 To Max
    Ar(i) = ClampDummy(Ar(i))
  Next i
  tDummy = QTime
  
  PrepareArray Ar
  QTimeReset -tDummy
  For i = 0 To Max
    Ar(i) = ClampMath(Ar(i))
  Next i
  tMath = QTime
  
  PrepareArray Ar
  QTimeReset -tDummy
  For i = 0 To Max
    Ar(i) = ClampCmov(Ar(i))
  Next i
  tCmov = QTime
  
  PrepareArray Ar
  QTimeReset -tDummy
  For i = 0 To Max
    Ar(i) = ClampIf(Ar(i))
  Next i
  tIf = QTime

  PrepareArray Ar
  QTimeReset -tDummy
  For i = 0 To Max
    Ar(i) = ClampLogic(Ar(i))
  Next i
  tLogic = QTime

  MsgBox Format(tIf, "0.000000") & " --- If" & vbNewLine & _
         Format(tCmov, "0.000000") & " --- CMOV" & vbNewLine & _
         Format(tMath, "0.000000") & " --- Math" & vbNewLine & _
         Format(tLogic, "0.000000") & " --- Logic" & vbNewLine

End Sub



Private Sub QTimeReset(ByVal Time As Double)
  MaxCur = CCur("922337203685477") + CCur(0.5807)
  MinCur = -MaxCur - CCur(0.0001)
  QueryPerformanceCounter OldQC
  QueryPerformanceFrequency QF
  QTimeVal = Time
End Sub

Private Function QTime() As Double
  Dim QC As Currency

  QueryPerformanceCounter QC
  If QC >= OldQC Then
    QTimeVal = QTimeVal + (QC - OldQC) / QF
  Else
    QTimeVal = QTimeVal + ((MaxCur - OldQC) + (QC - MinCur)) / QF
  End If
  OldQC = QC
  QTime = QTimeVal
End Function
